
// DCC turnout Decoder wac 20 Jan 2021 A6 does not work - changed to A5 for led and enable
// new sketch for v2 PCB dated Oct 2019
// t9 to t16 are momentary set at 50 milliseconds for turnouts
  
#include <NmraDcc.h>

//Settings
int tunAddr = 1; // DCC packet controls 4 turnouts for each address
int last_tun = 0;
int tun;
int state;
int last_state;
int amp = 0;
int t_on = 25;

byte out_pins [] = {0, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18};

boolean pulse;
boolean fault;

 
const int FunctionPin1a = 3; // define a function pairing to each pin
const int FunctionPin1b = 4;
const int FunctionPin2a = 5;
const int FunctionPin2b = 6;
const int FunctionPin3a = 7;
const int FunctionPin3b = 8;
const int FunctionPin4a = 9;
const int FunctionPin4b = 10;
const int FunctionPin5a = 11;
const int FunctionPin5b = 12;
const int FunctionPin6a = 13;  // internal led
const int FunctionPin6b = 14; // A0 as digital
const int FunctionPin7a = 15; // A1 as digital
const int FunctionPin7b = 16; // A2 as digital
const int FunctionPin8a = 17; // A3 as digital
const int FunctionPin8b = 18; // A4 as digital

const int led = 19; // led on pcb  A5
int currentSense = A7;  // analog pin for current sense


NmraDcc  Dcc ;
DCC_MSG  Packet ;

struct CVPair{
  uint16_t  CV;
  uint8_t   Value;
};


void setup() {
  analogReference(INTERNAL);
  
  pinMode(led, OUTPUT);
  digitalWrite(led, HIGH); 

  for (int i = 1; i <= 16; i++) {
    pinMode(out_pins[i], OUTPUT);
    digitalWrite(out_pins[i], LOW);
  }
  pulse = false;
  fault = false;
 
  Serial.begin(115200);
  // Setup which External Interrupt, the Pin it's associated with that we're using, disable pullup.
  Dcc.pin(0, 2, 0);
  // Call the main DCC Init function to enable the DCC Receiver
  Dcc.init( MAN_ID_DIY, 100,   FLAGS_DCC_ACCESSORY_DECODER , 0 ); 
  Serial.println("Ready");
  delay(1000);
  digitalWrite(led, LOW);
}
void current(){
   delay(2);
   amp = 10.8 * analogRead(currentSense);
if (amp > 150){
   Serial.print("current (mA) = ");
   Serial.println(amp);  //milli amps
}
  if (amp > 2000){   // approx 2 amps

  // Convert the analog reading (which goes from 0 - 1023) to a voltage (0 - 1.1V) = 1.08mv per division
  // 0.1 ohm resistor on current sense gives 200mv at 2 Amps or, 100mv per Amp
  // 1.08 mv per div for Internal Ref of 1.1v  : 100/1.08 = 92.6 divisions per 1000mA or 1 div = 10.8mA
  // current = 10.8 * currentSense ;  // mA
    
    digitalWrite(led, LOW);
    Serial.println("Over current - Power off");
    Serial.println(amp);  //Amps
    shut_down();
  }
}
void loop(){
  // You MUST call the NmraDcc.process() method frequently from the Arduino loop() function for correct library operation
  tunAddr = 0;
  current();
  if (fault == false){
  Dcc.process();
  }
   if (fault == true){
  return;
  }
   if (pulse == true){
    delay(t_on);
    //current();
    digitalWrite(FunctionPin1a,LOW);
    digitalWrite(FunctionPin1b,LOW);
    digitalWrite(FunctionPin2a,LOW);
    digitalWrite(FunctionPin2b,LOW);
    digitalWrite(FunctionPin3a,LOW);
    digitalWrite(FunctionPin3b,LOW);
    digitalWrite(FunctionPin4a,LOW);
    digitalWrite(FunctionPin4b,LOW);
    digitalWrite(FunctionPin5a,LOW);
    digitalWrite(FunctionPin5b,LOW);
    digitalWrite(FunctionPin6a,LOW);
    digitalWrite(FunctionPin6b,LOW);
    digitalWrite(FunctionPin7a,LOW);
    digitalWrite(FunctionPin7b,LOW);
    digitalWrite(FunctionPin8a,LOW);
    digitalWrite(FunctionPin8b,LOW);
    pulse = false;  }

}


extern void notifyDccMsg( DCC_MSG * Msg ) {
   
  if( ( Msg->Data[0] == 0 ) && ( Msg->Data[1] == 0 ) ) return;  //reset packlet
  if( ( Msg->Data[0] == 0b11111111 ) && ( Msg->Data[1] == 0 ) ) return;  //idle packet
  if(Msg->Data[0] == 100 && Msg->Data[1] == 63) return;
  
if ((Msg->Data[1]>>3) == 0x1f){    // B11111000 (0xf8) shifted 3 places to give B11111 (0x1f)    
  if( (Msg->Data[0] == 0x83) || (Msg->Data[0] == 0x84)){    // for tunAddr = 3,4 only for this sketch (see other sketch for tunAddr 1,2)
  tunAddr = (Msg->Data[0] - 0x80);
  tun = (((Msg->Data[1]) - 0xf8>>1) + 1);
  state = (Msg->Data[1] & 0x01);
   if (last_tun == tun && last_state == state) return;
   digitalWrite(led, HIGH);
   last_tun = tun;
   last_state = state;
   Serial.print("tunAddr = ");
   Serial.println(tunAddr);
   
   Serial.print("DccMsg - ");
   Serial.print(Msg->Size);
     Serial.print(" ");
     for(int i=0;i<Msg->Size;i++){
     Serial.print(Msg->Data[i], DEC);
     Serial.print(" ");
     }
   Serial.println();
   Serial.println(Msg->Data[0], BIN);
   Serial.println(Msg->Data[1], BIN);
   Serial.println((Msg->Data[1] - 0xf8)>>1, BIN);
   Serial.println(((Msg->Data[1] - 0xf8)>>1) + 1, DEC);
   Serial.println(((Msg->Data[1] - 0xf8)>>1) + 1 + (tunAddr-1)*4);       
   Serial.println(Msg->Data[1] & 0x01);
   Serial.print("Turnout = ");
   Serial.println(((Msg->Data[1] - 0xf8) >>1) + 1 + (tunAddr-1)*4);
   Serial.print("tun = ");
   Serial.println(tun);
  }
}

if (tunAddr == 3){ 
   if ((((Msg->Data[1]) - 0xf8>>1) + 1) == 1 && (Msg->Data[1] & 0x01) == 1){         //    f1a on
         // pin 3 
         digitalWrite(FunctionPin1a, 1);
         pulse = true;
         t_on = 50;    
    }
   if ((((Msg->Data[1]) - 0xf8>>1) + 1) == 1 && (Msg->Data[1] & 0x01) == 0){         //    f1b on
         // pin 4   
         digitalWrite(FunctionPin1b, 1);
         pulse = true;
         t_on = 50;    
    }
   if ((((Msg->Data[1]) - 0xf8>>1) + 1) == 2 && (Msg->Data[1] & 0x01) == 1){         //    f2a on
         // pin 5     
         digitalWrite(FunctionPin2a, 1);
         pulse = true;
         t_on = 50;
    }      
  if ((((Msg->Data[1]) - 0xf8>>1) + 1) == 2 && (Msg->Data[1] & 0x01) == 0){         //    f2b on
         // pin 6     
         digitalWrite(FunctionPin2b, 1);
         pulse = true;
         t_on = 50;
    }   
    if ((((Msg->Data[1]) - 0xf8>>1) + 1) == 3 && (Msg->Data[1] & 0x01) == 1){         //    f3a on
         // pin 7      
         digitalWrite(FunctionPin3a, 1);
         pulse = true;
         t_on = 50;
    }      
  if ((((Msg->Data[1]) - 0xf8>>1) + 1) == 3 && (Msg->Data[1] & 0x01) == 0){         //    f3b on
         /// pin 8     
         digitalWrite(FunctionPin3b, 1);
         pulse = true;
         t_on = 50;
    }   
   if ((((Msg->Data[1]) - 0xf8>>1) + 1) == 4 && (Msg->Data[1] & 0x01) == 1){         //    f4a on
         // pin 9
         digitalWrite(FunctionPin4a, 1);
         pulse = true;
         t_on = 50;
    } 
  if ((((Msg->Data[1]) - 0xf8>>1) + 1) == 4 && (Msg->Data[1] & 0x01) == 0){         //    f4b on
         // pin 10     
         digitalWrite(FunctionPin4b, 1);
         pulse = true;
         t_on = 50;
    }   
}

if (tunAddr == 4){
  if ((((Msg->Data[1]) - 0xf8>>1) + 1) == 1 && (Msg->Data[1] & 0x01) == 1){         //    f5a on
         // pin 11     
         digitalWrite(FunctionPin5a, 1);
         pulse = true;
         t_on = 50;
    }      
  if ((((Msg->Data[1]) - 0xf8>>1) + 1) == 1 && (Msg->Data[1] & 0x01) == 0){         //    f5b on
         // pin 12     
         digitalWrite(FunctionPin5b, 1);
         pulse = true;
         t_on = 50;
    }   
  if ((((Msg->Data[1]) - 0xf8>>1) + 1) == 2 && (Msg->Data[1] & 0x01) == 1){         //    f6a on
         // pin 13     
         digitalWrite(FunctionPin6a, 1);
         pulse = true;
         t_on = 50;     
    }      
  if ((((Msg->Data[1]) - 0xf8>>1) + 1) == 2 && (Msg->Data[1] & 0x01) == 0){         //    f6b on
         // pin A0   
         digitalWrite(FunctionPin6b, 1);
         pulse = true;
         t_on = 50;     
    }   
 if ((((Msg->Data[1]) - 0xf8>>1) + 1) == 3 && (Msg->Data[1] & 0x01) == 1){         //   f7a on
         // pin A1                                                                       
         digitalWrite(FunctionPin7a, 1);
         pulse = true; 
         t_on = 50;
    }      
  if ((((Msg->Data[1]) - 0xf8>>1) + 1) == 3 && (Msg->Data[1] & 0x01) == 0){         //   f7b off 
           // pin A2                                                                      
         digitalWrite(FunctionPin7b, 1);
         pulse = true;
         t_on = 50;
    }   
   if ((((Msg->Data[1]) - 0xf8>>1) + 1) == 4 && (Msg->Data[1] & 0x01) == 1){         //   f8a on
          // pin A3                                                                           
         digitalWrite(FunctionPin8a, 1);
         pulse = true;
         t_on = 50;
    }
   if ((((Msg->Data[1]) - 0xf8>>1) + 1) == 4 && (Msg->Data[1] & 0x01) == 0){         //   f8b off 
           // pin A4                                                                          
         digitalWrite(FunctionPin8b, 1);
         pulse = true;
         t_on = 50;
   }   
}
Msg->Data[0] == 0;
}

void shut_down(){
    digitalWrite(led,LOW);
    fault = true;
    Serial.println("Shut down");
}
